#include <bits/stdc++.h>
#include "robot.h"
using namespace std;

vector<vector<bool>> g;
int n,m;
int dist[10][10];
bool can_move(int x, int y) {
    return (x>=0 and y>=0 and x<n and y<m and !g[x][y]);
}

int a, b, c, d;
int dx[4] = {-1, 1, 0, 0};
int dy[4] = { 0, 0,-1, 1};
void move2(int dir) {
    if(can_move(a+dx[dir], b+dy[dir])) {
        a += dx[dir];
        b += dy[dir];
    }
    if(can_move(c+dx[dir], d+dy[dir])) {
        c += dx[dir];
        d += dy[dir];
    }
    switch(dir) {
    case 0:
        up();
        break;
    case 1:
        down();
        break;
    case 2:
        left();
        break;
    case 3:
        right();
        break;
    default:
        assert(false);
    }
    cerr << a << b << c << d << " " << dir << "\n";
}

// takes the (1-step) instruction that moves (c,d) to (a,b)
void mv() {
    cerr << "next iter\n";
    for(int i=0; i<n; i++) {
        for(int j=0; j<m; j++) {
            dist[i][j] = 1e9;
        }
    }
    dist[a][b] = 0;
    queue<pair<int,int>> q;
    q.emplace(a,b);
    while(!q.empty()) {
        pair<int,int> next = q.front();
        q.pop();

        for(int dir=0; dir<4; dir++) {
            int x_new = next.first + dx[dir];
            int y_new = next.second + dy[dir];
            if(can_move(x_new, y_new) and dist[x_new][y_new]==1e9) {
                dist[x_new][y_new] = dist[next.first][next.second]+1;
                q.emplace(x_new, y_new);
            }
        }
    }
    for(int dir=0; dir<4; dir++) {
        int c_new = c+dx[dir];
        int d_new = d+dy[dir];
        if(can_move(c_new, d_new) and dist[c_new][d_new] < dist[c][d]) {

            move2(dir);
            return;
        }
    }
    assert(false); // something is wrong with bfs
}

void construct_instructions(vector<vector<bool>> _g, int q, int _a, int _b, int _c, int _d) {
    g = _g;
    n = g.size();
    m = g[0].size();
    a = _a;
    b = _b;
    c = _c;
    d = _d;
    while(a!=c or b!=d) {
        mv();
    }
    while(c!=0 or d!=0) {
        // now put a "fake" target at (0,0)
        a = 0;
        b = 0;
        mv();
    }
}
